import React , { useState } from 'react';
import { StyleSheet, Text, View, TextInput, Button } from 'react-native';


export default class Col extends React.Component {
	constructor(props){
		super(props);
	}

	render() {
		let {
			children,
			selected,
			...restProps
		} = this.props;

		let styl = [styles.column];
		if (selected) styl.push(styles.selected);

		return (
		    <View {...restProps} style={styl}>
		    	{children}
		    </View>
		);
	}
}

const styles = StyleSheet.create({
	column: {
		flex: 1,
		justifyContent: 'flex-start'
	},
	selected: {
		// boxShadow: 'inset 0px 0px 1px 1px rgba(250,10,0,0.81)'
		shadowColor: "rgba(250,10,0,0.81)",
		shadowOffset: {
			width: 0,
			height: 4,
		},
		shadowOpacity: 0.30,
		shadowRadius: 4.65,

		elevation: 8,
	}
});